diff --git a/gdb/Makefile.in b/gdb/Makefile.in
index be769280a9..67fff669ba 100644
--- a/gdb/Makefile.in
+++ b/gdb/Makefile.in
@@ -319,9 +319,7 @@ SUBDIR_GCC_COMPILE_SRCS = \
 	compile/compile-c-types.c \
 	compile/compile-loc2c.c \
 	compile/compile-object-load.c \
-	compile/compile-object-load.h \
-	compile/compile-object-run.c \
-	compile/compile-object-run.h
+	compile/compile-object-run.c
 
 SUBDIR_GCC_COMPILE_OBS = $(patsubst %.c,%.o,$(filter %.c,$(SUBDIR_GCC_COMPILE_SRCS)))
 
@@ -1453,7 +1451,11 @@ HFILES_NO_SRCDIR = \
 	common/version.h \
 	common/x86-xstate.h \
 	common/xml-utils.h \
+	compile/compile-c.h \
 	compile/compile.h \
+	compile/compile-internal.h \
+	compile/compile-object-load.h \
+	compile/compile-object-run.h \
 	config/nm-linux.h \
 	config/nm-nto.h \
 	config/djgpp/langinfo.h \
diff --git a/gdb/compile/compile-c-support.c b/gdb/compile/compile-c-support.c
index 696bb9fced..41fead9ad1 100644
--- a/gdb/compile/compile-c-support.c
+++ b/gdb/compile/compile-c-support.c
@@ -19,6 +19,7 @@
 
 #include "defs.h"
 #include "compile-internal.h"
+#include "compile-c.h"
 #include "compile.h"
 #include "gdb-dlfcn.h"
 #include "c-lang.h"
diff --git a/gdb/compile/compile-c-symbols.c b/gdb/compile/compile-c-symbols.c
index 9364fc27ac..c82e008659 100644
--- a/gdb/compile/compile-c-symbols.c
+++ b/gdb/compile/compile-c-symbols.c
@@ -20,6 +20,7 @@
 
 #include "defs.h"
 #include "compile-internal.h"
+#include "compile-c.h"
 #include "symtab.h"
 #include "parser-defs.h"
 #include "block.h"
@@ -706,7 +707,7 @@ generate_c_for_for_one_variable (struct compile_c_instance *compiler,
   END_CATCH
 }
 
-/* See compile-internal.h.  */
+/* See compile-c.h.  */
 
 gdb::unique_xmalloc_ptr<unsigned char>
 generate_c_for_variable_locations (struct compile_c_instance *compiler,
diff --git a/gdb/compile/compile-c-types.c b/gdb/compile/compile-c-types.c
index 212cfe66be..46b9f2b3b4 100644
--- a/gdb/compile/compile-c-types.c
+++ b/gdb/compile/compile-c-types.c
@@ -21,6 +21,7 @@
 #include "defs.h"
 #include "gdbtypes.h"
 #include "compile-internal.h"
+#include "compile-c.h"
 #include "objfiles.h"
 
 /* An object that maps a gdb type to a gcc type.  */
diff --git a/gdb/compile/compile-c.h b/gdb/compile/compile-c.h
new file mode 100644
index 0000000000..cff2aef906
--- /dev/null
+++ b/gdb/compile/compile-c.h
@@ -0,0 +1,81 @@
+/* Header file for GDB compile C-language support.
+   Copyright (C) 2014-2018 Free Software Foundation, Inc.
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 3 of the License, or
+   (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */
+
+#ifndef GDB_COMPILE_C_H
+#define GDB_COMPILE_C_H
+
+#include "common/enum-flags.h"
+#include "hashtab.h"
+
+/* enum-flags wrapper.  */
+
+DEF_ENUM_FLAGS_TYPE (enum gcc_qualifiers, gcc_qualifiers_flags);
+
+/* A callback suitable for use as the GCC C symbol oracle.  */
+
+extern gcc_c_oracle_function gcc_convert_symbol;
+
+/* A callback suitable for use as the GCC C address oracle.  */
+
+extern gcc_c_symbol_address_function gcc_symbol_address;
+
+/* A subclass of compile_instance that is specific to the C front
+   end.  */
+
+struct compile_c_instance
+{
+  /* Base class.  Note that the base class vtable actually points to a
+     gcc_c_fe_vtable.  */
+  struct compile_instance base;
+
+  /* Map from gdb types to gcc types.  */
+  htab_t type_map;
+
+  /* Map from gdb symbols to gcc error messages to emit.  */
+  htab_t symbol_err_map;
+};
+
+/* A helper macro that takes a compile_c_instance and returns its
+   corresponding gcc_c_context.  */
+
+#define C_CTX(I) ((struct gcc_c_context *) ((I)->base.fe))
+
+/* Emit code to compute the address for all the local variables in
+   scope at PC in BLOCK.  Returns a malloc'd vector, indexed by gdb
+   register number, where each element indicates if the corresponding
+   register is needed to compute a local variable.  */
+
+extern gdb::unique_xmalloc_ptr<unsigned char>
+  generate_c_for_variable_locations
+     (struct compile_c_instance *compiler,
+      string_file &stream,
+      struct gdbarch *gdbarch,
+      const struct block *block,
+      CORE_ADDR pc);
+
+/* Get the GCC mode attribute value for a given type size.  */
+
+extern const char *c_get_mode_for_size (int size);
+
+/* Given a dynamic property, return an xmallocd name that is used to
+   represent its size.  The result must be freed by the caller.  The
+   contents of the resulting string will be the same each time for
+   each call with the same argument.  */
+
+struct dynamic_prop;
+extern std::string c_get_range_decl_name (const struct dynamic_prop *prop);
+
+#endif /* GDB_COMPILE_C_H  */
diff --git a/gdb/compile/compile-internal.h b/gdb/compile/compile-internal.h
index 01beb1dddd..afe20e5141 100644
--- a/gdb/compile/compile-internal.h
+++ b/gdb/compile/compile-internal.h
@@ -17,12 +17,7 @@
 #ifndef GDB_COMPILE_INTERNAL_H
 #define GDB_COMPILE_INTERNAL_H
 
-#include "hashtab.h"
 #include "gcc-c-interface.h"
-#include "common/enum-flags.h"
-
-/* enum-flags wrapper.  */
-DEF_ENUM_FLAGS_TYPE (enum gcc_qualifiers, gcc_qualifiers_flags);
 
 /* Debugging flag for the "compile" family of commands.  */
 
@@ -57,29 +52,6 @@ struct compile_instance
   void (*destroy) (struct compile_instance *);
 };
 
-/* A subclass of compile_instance that is specific to the C front
-   end.  */
-struct compile_c_instance
-{
-  /* Base class.  Note that the base class vtable actually points to a
-     gcc_c_fe_vtable.  */
-
-  struct compile_instance base;
-
-  /* Map from gdb types to gcc types.  */
-
-  htab_t type_map;
-
-  /* Map from gdb symbols to gcc error messages to emit.  */
-
-  htab_t symbol_err_map;
-};
-
-/* A helper macro that takes a compile_c_instance and returns its
-   corresponding gcc_c_context.  */
-
-#define C_CTX(I) ((struct gcc_c_context *) ((I)->base.fe))
-
 /* Define header and footers for different scopes.  */
 
 /* A simple scope just declares a function named "_gdb_expr", takes no
@@ -114,43 +86,11 @@ struct type;
 extern gcc_type convert_type (struct compile_c_instance *context,
 			      struct type *type);
 
-/* A callback suitable for use as the GCC C symbol oracle.  */
-
-extern gcc_c_oracle_function gcc_convert_symbol;
-
-/* A callback suitable for use as the GCC C address oracle.  */
-
-extern gcc_c_symbol_address_function gcc_symbol_address;
-
 /* Instantiate a GDB object holding state for the GCC context FE.  The
    new object is returned.  */
 
 extern struct compile_instance *new_compile_instance (struct gcc_c_context *fe);
 
-/* Emit code to compute the address for all the local variables in
-   scope at PC in BLOCK.  Returns a vector, indexed by gdb register
-   number, where each element indicates if the corresponding register
-   is needed to compute a local variable.  */
-
-extern gdb::unique_xmalloc_ptr<unsigned char>
-  generate_c_for_variable_locations
-     (struct compile_c_instance *compiler,
-      string_file &stream,
-      struct gdbarch *gdbarch,
-      const struct block *block,
-      CORE_ADDR pc);
-
-/* Get the GCC mode attribute value for a given type size.  */
-
-extern const char *c_get_mode_for_size (int size);
-
-/* Given a dynamic property, return a name that is used to represent
-   its size.  The contents of the resulting string will be the same
-   each time for each call with the same argument.  */
-
-struct dynamic_prop;
-extern std::string c_get_range_decl_name (const struct dynamic_prop *prop);
-
 /* Type used to hold and pass around the source and object file names
    to use for compilation.  */
 class compile_file_names
diff --git a/gdb/compile/compile-loc2c.c b/gdb/compile/compile-loc2c.c
index aba791a20f..bd080f85fb 100644
--- a/gdb/compile/compile-loc2c.c
+++ b/gdb/compile/compile-loc2c.c
@@ -24,6 +24,7 @@
 #include "ui-file.h"
 #include "utils.h"
 #include "compile-internal.h"
+#include "compile-c.h"
 #include "compile.h"
 #include "block.h"
 #include "dwarf2-frame.h"