diff --git a/gdb/Makefile.in b/gdb/Makefile.in
index 354a6361b7..f8cdf9a560 100644
--- a/gdb/Makefile.in
+++ b/gdb/Makefile.in
@@ -416,6 +416,7 @@ SUBDIR_PYTHON_CFLAGS =
 
 SUBDIR_UNITTESTS_SRCS = \
 	unittests/array-view-selftests.c \
+	unittests/cli-utils-selftests.c \
 	unittests/common-utils-selftests.c \
 	unittests/environ-selftests.c \
 	unittests/format_pieces-selftests.c \
diff --git a/gdb/unittests/cli-utils-selftests.c b/gdb/unittests/cli-utils-selftests.c
new file mode 100644
index 0000000000..68ae89008b
--- /dev/null
+++ b/gdb/unittests/cli-utils-selftests.c
@@ -0,0 +1,238 @@
+/* Unit tests for the cli-utils.c file.
+
+   Copyright (C) 2018 Free Software Foundation, Inc.
+
+   This file is part of GDB.
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 3 of the License, or
+   (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */
+
+#include "defs.h"
+#include "cli/cli-utils.h"
+#include "selftest.h"
+
+namespace selftests {
+namespace cli_utils {
+
+static void
+test_number_or_range_parser ()
+{
+  number_or_range_parser one ("1");
+
+  SELF_CHECK (one.finished () == false);
+  SELF_CHECK (one.get_number () == 1);
+  SELF_CHECK (one.finished () == true);
+  SELF_CHECK (strcmp (one.cur_tok (), "") == 0);
+
+  number_or_range_parser one_after ("1 after");
+
+  SELF_CHECK (one_after.finished () == false);
+  SELF_CHECK (one_after.get_number () == 1);
+  // SELF_CHECK (one_after.finished () == true);
+  // number_or_range_parser is cumbersome : to have finished == true,
+  // you have to call get_number once more. But then, the cur_tok is wrong.
+  // It should be restructured to have the setup (e.g. discovering if
+  // we have a number or a range or something else) in the init phase.
+  // This allows to indicate finished == true just after init,
+  // in case the init string is not a number or range.
+  SELF_CHECK (strcmp (one_after.cur_tok (), "after") == 0);
+
+  number_or_range_parser one_three ("1-3");
+
+  for (int i = 1; i < 4; i++) {
+    SELF_CHECK (one_three.finished () == false);
+    SELF_CHECK (one_three.get_number () == i);
+  }
+  SELF_CHECK (one_three.finished () == true);
+  SELF_CHECK (strcmp (one_three.cur_tok (), "") == 0);
+
+  number_or_range_parser one_three_after ("1-3 after");
+
+  for (int i = 1; i < 4; i++) {
+    SELF_CHECK (one_three_after.finished () == false);
+    SELF_CHECK (one_three_after.get_number () == i);
+  }
+  // SELF_CHECK (one_three_after.finished () == true);
+  // See above.
+  SELF_CHECK (strcmp (one_three_after.cur_tok (), "after") == 0);
+
+  number_or_range_parser minus_one ("-1");
+
+  SELF_CHECK (minus_one.finished () == false);
+  TRY
+    {
+      minus_one.get_number ();
+      SELF_CHECK (false);
+    }
+  CATCH (ex, RETURN_MASK_ERROR)
+    {
+      SELF_CHECK (ex.reason == RETURN_ERROR);
+      SELF_CHECK (ex.error == GENERIC_ERROR);
+      SELF_CHECK (strcmp (ex.message, "negative value") == 0);
+      SELF_CHECK (strcmp (minus_one.cur_tok (), "-1") == 0);
+    }
+  END_CATCH;
+
+  number_or_range_parser nan ("-whatever");
+
+  // SELF_CHECK (nan.finished () == true);
+  // See above
+  SELF_CHECK (one_three_after.get_number () == 0);
+  SELF_CHECK (strcmp (nan.cur_tok (), "-whatever") == 0);
+}
+
+static void
+test_check_for_flags ()
+{
+  const char *flags = "abc";
+  const char *non_flags_args = "non flags args";
+  int flags_counts[strlen (flags)];
+  int res;
+
+  const char *t1 = "-a -a non flags args";
+
+  SELF_CHECK (check_for_flags (&t1, flags, flags_counts) == 1);
+  SELF_CHECK (strcmp (t1, non_flags_args) == 0);
+  SELF_CHECK (flags_counts[0] == 2
+	      && flags_counts[1] == 0
+	      && flags_counts[2] == 0);
+
+  const char *t2 = "-c     -b -c  -b -c    non flags args";
+
+  SELF_CHECK (check_for_flags (&t2, flags, flags_counts) == 1);
+  SELF_CHECK (strcmp (t2, non_flags_args) == 0);
+  SELF_CHECK (flags_counts[0] == 0
+	      && flags_counts[1] == 2
+	      && flags_counts[2] == 3);
+
+  const char *t3 = non_flags_args;
+
+  SELF_CHECK (check_for_flags (&t3, flags, flags_counts) == 0);
+  SELF_CHECK (strcmp (t3, non_flags_args) == 0);
+  SELF_CHECK (flags_counts[0] == 0
+	      && flags_counts[1] == 0
+	      && flags_counts[2] == 0);
+
+  const char *t4 = "-c -b -x -y -z -c";
+  const char *orig_t4 = t4;
+
+  SELF_CHECK (check_for_flags (&t4, flags, flags_counts) == -1);
+  SELF_CHECK (strcmp (t4, orig_t4) == 0);
+  SELF_CHECK (flags_counts[0] == 0
+	      && flags_counts[1] == 1
+	      && flags_counts[2] == 1);
+
+  const char *t5 = "-c -cb -c";
+  const char *orig_t5 = t5;
+
+  SELF_CHECK (check_for_flags (&t5, flags, flags_counts) == -1);
+  SELF_CHECK (strcmp (t5, orig_t5) == 0);
+  SELF_CHECK (flags_counts[0] == 0
+	      && flags_counts[1] == 0
+	      && flags_counts[2] == 1);
+
+}
+
+static void
+test_check_for_flags_vqcs ()
+{
+  int verbosity;
+  bool cont;
+  bool silent;
+  const char *non_flags_args = "non flags args";
+
+  const char *t1 = "-v -v -v -q -q -q -s    non flags args";
+
+  verbosity = 1;
+  cont = true;
+  silent = false;
+  SELF_CHECK (check_for_flags_vqcs ("test_check_for_flags_vqcs.t1",
+				    &t1,
+				    &verbosity,
+				    4, &cont, &silent) == 1);
+  SELF_CHECK (verbosity == 1);
+  SELF_CHECK (cont == false && silent == true);
+  SELF_CHECK (strcmp (t1, non_flags_args) == 0);
+
+  const char *t2 = "non flags args";
+
+  verbosity = 2;
+  cont = true;
+  silent = true;
+  SELF_CHECK (check_for_flags_vqcs ("test_check_for_flags_vqcs.t2",
+				    &t2,
+				    &verbosity,
+				    4, &cont, &silent) == 0);
+  SELF_CHECK (verbosity == 2);
+  SELF_CHECK (cont == false && silent == false);
+  SELF_CHECK (strcmp (t2, non_flags_args) == 0);
+
+  const char *t3 = "-123 non flags args";
+  const char *orig_t3 = t3;
+
+  verbosity = 3;
+  cont = true;
+  silent = true;
+  SELF_CHECK (check_for_flags_vqcs ("test_check_for_flags_vqcs.t3",
+				    &t3,
+				    &verbosity,
+				    4, &cont, &silent) == 0);
+  SELF_CHECK (verbosity == 3);
+  SELF_CHECK (cont == false && silent == false);
+  SELF_CHECK (strcmp (t3, orig_t3) == 0);
+
+  const char *t4 = "-q -q -x -y -z non flags args";
+  const char *orig_t4 = t4;
+  TRY
+    {
+      verbosity = 4;
+      cont = true;
+      silent = true;
+      (void) check_for_flags_vqcs ("test_check_for_flags_vqcs.t4",
+				   &t4,
+				   &verbosity,
+				   4, &cont, &silent);
+      SELF_CHECK (false);
+    }
+  CATCH (ex, RETURN_MASK_ERROR)
+    {
+      SELF_CHECK (ex.reason == RETURN_ERROR);
+      SELF_CHECK (ex.error == GENERIC_ERROR);
+      SELF_CHECK
+	(strcmp (ex.message,
+		 "test_check_for_flags_vqcs.t4 "
+		 "only accepts flags vqcs given individually") == 0);
+      SELF_CHECK (strcmp (t4, orig_t4) == 0);
+      SELF_CHECK (verbosity == 4);
+    }
+  END_CATCH;
+
+}
+
+static void
+test_cli_utils ()
+{
+  selftests::cli_utils::test_number_or_range_parser ();
+  selftests::cli_utils::test_check_for_flags ();
+  selftests::cli_utils::test_check_for_flags_vqcs ();
+}
+
+}
+}
+
+void
+_initialize_cli_utils_selftests ()
+{
+  selftests::register_test ("cli_utils",
+			    selftests::cli_utils::test_cli_utils);
+}